import {createRoute, OpenAPIHono, z} from "@hono/zod-openapi";
import {authMiddleware} from "../../auth/middleware/authMiddleware.js";
import {apiHit} from "../../../globalUtils/apiHits.js";
import {initializeProdPool} from "../prodSqlServer.js";

const app = new OpenAPIHono();

const responseSchema = z.object({
    success: z.boolean().openapi({example: true}),
    message: z.string().optional().openapi({example: "user access"}),
});

app.openapi(
    createRoute({
        tags: ["Server:PRODSQL"],
        summary: "Connects to the sql server",
        method: "get",
        path: "/",
        middleware: authMiddleware,
        description: "Initilized the connetion",
        responses: {
            200: {
                content: {"application/json": {schema: responseSchema}},
                description: "restarred",
            },
            400: {
                content: {"application/json": {schema: responseSchema}},
                description: "Failed start",
            },
        },
    }),
    async (c) => {
        apiHit(c, {endpoint: "api/sqlProd/connect"});

        try {
            const pool = await initializeProdPool();
            //return apiReturn(c, true, access?.message, access?.data, 200);
            return c.json({success: pool.success, message: pool.message}, 200);
        } catch (error) {
            console.log(error);
            //return apiReturn(c, false, "Error in setting the user access", error, 400);
            return c.json({success: false, message: "Error in initalizing the connection", data: error}, 400);
        }
    }
);
export default app;
